#<profile4xi profile = "11" />
# -------------------------------------------------------------------------------------------------
#<program4xi program = "hello_pipe4xi.py">
#<abstract4xi abstract = "tests pipe4xi"/>
#<refer4xi reference = "DragonXi"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
#<verify4xi verification = "10" target = "process4xi.py"/>
#<contextualize4xi context = "pipe4xi.py; forkingpickler4xi.py; popen4xi.py; current_process4xi.py"/>
# ------------------------------------------------------------------------------------------------- 

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'main',
            'hello_pipe4xi',
            'print_trace4xi',
            'set_trace4xi',
            'f4xi',
            'f2xi',
            'f']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import array
import _winapi
#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
import _multiprocessing
from multiprocessing.process import Process
from multiprocessing.queues  import Queue
from multiprocessing.connection import Pipe
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "

from process2xi import Process2Xi
from queue2xi  import Queue2Xi
from pipe2xi import Pipe2Xi

from pipe4xi import Pipe4Xi
from process4xi import Process4Xi

from queue4xi  import Queue4Xi

from time4xi import time4xi

from print4xi import Print4Xi
from pickle4xi import pickle4xi
from pickle2a4xi import Pickle2a4Xi
from pickle2b4xi import Pickle2b4Xi
from pickle2c4xi import Pickle2c4Xi
from pickle2d4xi import Pickle2d4Xi
from pickle2e4xi import Pickle2e4Xi
from pickle2f4xi import Pickle2f4Xi
from pickle2g4xi import Pickle2g4Xi
from pickle2h4xi import Pickle2h4Xi
from pickle2i4xi import Pickle2i4Xi
from pickle2j4xi import Pickle2j4Xi
from pickle2k4xi import Pickle2k4Xi
from pickle2l4xi import Pickle2l4Xi
from pickle2m4xi import Pickle2m4Xi
from pickle2n4xi import Pickle2n4Xi
from pickle2o4xi import Pickle2o4Xi
from pickle2p4xi import Pickle2p4Xi
from pickle2q4xi import Pickle2q4Xi
from pickle2r4xi import Pickle2r4Xi
from pickle2s4xi import Pickle2s4Xi
from pickle2t4xi import Pickle2t4Xi
from pickle2u4xi import Pickle2u4Xi
from pickle2v4xi import Pickle2v4Xi
from pickle2w4xi import Pickle2w4Xi
from pickle2x4xi import Pickle2x4Xi
from pickle2y4xi import Pickle2y4Xi
from pickle2z4xi import Pickle2z4Xi
from pickle2_4xi import Pickle2_4Xi      

from xml_trace_sense4xi import xml_trace_sense4xi
from xml_trace_reason4xi import xml_trace_reason4xi
from xml_trace_ace4xi import xml_trace_ace4xi 
#" 
#/>



# -------------------------------------------------------------------------------------------------
#<function4xi function = "f" usage = "
#   Hello from Standard Multiprocessing Pipe!
#">                         
# ------------------------------------------------------------------------------------------------- 

def f():
    print ('Hello from standard multiprocessing Pipe!')
#</function4xi>
 
# -------------------------------------------------------------------------------------------------
#<function4xi function = "f2xi" usage = "
#   Hello from layered multiprocessing2xi Pipe2Xi!
#">                         
# ------------------------------------------------------------------------------------------------- 
    
def f2xi():
    print ('Hello from layered multiprocessing2xi Pipe2Xi!')
#</function4xi>
 
# -------------------------------------------------------------------------------------------------
#<function4xi function = "f4xi" usage = "
#   Hello from dragonized multiprocessing4xi Pipe4Xi!
#">                         
# ------------------------------------------------------------------------------------------------- 

def f4xi():
    print ('Hello from dragonized multiprocessing4xi Pipe4Xi!')    
#</function4xi>
 

# -------------------------------------------------------------------------------------------------
# Global constants                            
# ------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "
global t2xi 
global trace_object_count
global PickleKB4Xi

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
PickleKB4Xi = {
       'a': Pickle2a4Xi,
       'b': Pickle2b4Xi,
       'c': Pickle2c4Xi,
       'd': Pickle2d4Xi,
       'e': Pickle2e4Xi,
       'f': Pickle2f4Xi,
       'g': Pickle2g4Xi,
       'h': Pickle2h4Xi,
       'i': Pickle2i4Xi,
       'j': Pickle2j4Xi,
       'k': Pickle2k4Xi,
       'l': Pickle2l4Xi,
       'm': Pickle2m4Xi,
       'n': Pickle2n4Xi,
       'o': Pickle2o4Xi,
       'p': Pickle2p4Xi,
       'q': Pickle2q4Xi,
       'r': Pickle2r4Xi,
       's': Pickle2s4Xi,
       't': Pickle2t4Xi,
       'u': Pickle2u4Xi,
       'v': Pickle2v4Xi,
       'w': Pickle2w4Xi,
       'x': Pickle2x4Xi,
       'y': Pickle2y4Xi,
       'z': Pickle2z4Xi,
       '_': Pickle2_4Xi} 
#"
#"/>

# ----------------------------------------------------------------------------------------------------------
#<function4xi function = "set2trace4xi" usage = "setting trace using definitions in pickle4xi functions !
#">                      
# ----------------------------------------------------------------------------------------------------------    
def set2trace4xi():
    global t2xi 
    global trace_object_count
    global PickleKB4Xi

    # print("(Step 0A/33) OF SET2TRACE4XI - STARTING SETTING TRACE BASED ON TRACE SETTINGS IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
    # print("(Step 0B/33) OF SET2TRACE4XI - USING T2XI: ", t2xi)
    # <print4xi.Print4Xi object at 0x0000000003715080>    
    
    # ---------------------------------------------------------------------------------------------
    # A, B .... _ 
    # ---------------------------------------------------------------------------------------------
    keys2pickledb = sorted(PickleKB4Xi.keys())
    for key2pickledb in keys2pickledb:
        # -----------------------------------------------------------------------------------------    
        # LETTERS
        # -----------------------------------------------------------------------------------------     
        # print('=' *33)
        # print("STARTING LETTER : ", key2pickledb)
        # print('=' *33)
   
        dictionary2pickle = PickleKB4Xi[key2pickledb]        
        # print("STARTING DICTIONARY: ", dictionary2pickle)
        # print('~' *33) 
        # 
        keys2dictionary = sorted(dictionary2pickle.keys())
    
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     
        for key2dictionary in keys2dictionary:
            # -------------------------------------------------------------------------------------    
            # DICTIONARY
            # -------------------------------------------------------------------------------------     
            # print('~' *33)        
            object2pickle = key2dictionary        
            # print("STARTING OBJECT: ", object2pickle)
            # print('~' *33)         
            # pickle4xi(object2pickle)
            # print('~' *33)                  
            # print("PICKLED object: ", object2pickle)
            # PICKLED object:  _C4Xi, 
            # ---------------------------------------------------------------------------------    
            # Mark those with NACK4XI to be traced !
            # ---------------------------------------------------------------------------------     
            if dictionary2pickle[key2dictionary] == 'NACK4XI':
                set_param2xi = True     
                key_param = object2pickle     
                t2xi.set_print_permission(key_param, set_param2xi)
                # print("(Step 2A/33) OF SET2TRACE4XI - MARKED TO BE TRACED OBJECT: ", object2pickle)                                
                # 
            else:
                pass  
            # ---------------------------------------------------------------------------------    
            # END OF DICTIONARY
            # ---------------------------------------------------------------------------------     
        # -----------------------------------------------------------------------------------------    
        # END OF LETTERS
        # -----------------------------------------------------------------------------------------     
        # print('~' *33)        
        # print("COMPLETED  DICTIONARY: ", dictionary2pickle)
        # print('~' *33) 
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------     
    # print('=' *33)
    # print("COMPLETED LETTER : ", key2pickledb)
    # print('=' *33)
    # ---------------------------------------------------------------------------------------------
    # 
    # ---------------------------------------------------------------------------------------------
    print('=' *33)
    print("(Step 33/33) OF SET2TRACE4XI - COMPLETED SETTING TRACE BASED ON NACK4XI/ACK4XI SETTINGS IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
    print('=' *33)
#</function4xi> 

       
# -------------------------------------------------------------------------------------------------
#<function4xi function = "deny2trace4xi" usage = "
#   deny trace using pickle4xi functions !
#">                      
# -------------------------------------------------------------------------------------------------    
def deny2trace4xi():
    global t2xi 
    global trace_object_count
    global PickleKB4Xi

    print("(Step 01A/33) of DENY2TRACE4XI: STARTING DENYING TRACE IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
    print("(Step 01B/33) OF DENY2TRACE4XI - USING T2XI: ", t2xi)
    # <print4xi.Print4Xi object at 0x0000000003715080>
    
    # ---------------------------------------------------------------------------------------------
    # A, B .... _ 
    # ---------------------------------------------------------------------------------------------
    keys2pickledb = sorted(PickleKB4Xi.keys())
    for key2pickledb in keys2pickledb:
        # -----------------------------------------------------------------------------------------    
        # LETTERS
        # -----------------------------------------------------------------------------------------     
        # print("(Step 02A/33) OF DENY2TRACE4XI - STARTING LETTER : ", key2pickledb)
        dictionary2pickle = PickleKB4Xi[key2pickledb]        
        # print("(Step 02B/33) OF DENY2TRACE4XI - STARTING DICTIONARY: ", dictionary2pickle)
        keys2dictionary = sorted(dictionary2pickle.keys())
        # -----------------------------------------------------------------------------------------    
        #
        # -----------------------------------------------------------------------------------------     
        for key2dictionary in keys2dictionary:
   
            # -------------------------------------------------------------------------------------    
            # DICTIONARY
   
            object2pickle = key2dictionary        
            # print("(Step 02C/33) OF DENY2TRACE4XI - STARTING OBJECT: ", object2pickle)
            # pickle4xi(object2pickle)        
            # print("STEP: PICKLED object: ", object2pickle)
            # PICKLED object:  _C4Xi, 
            
            # ---------------------------------------------------------------------------------    
            # ACK4XI = tested .i.e. NOT to be traced! 
            # ---------------------------------------------------------------------------------     
            set_param2xi = 'ACK4XI'     
            key_param = object2pickle     
            t2xi.set_print_permission(key_param, set_param2xi)
            # print("(Step 02D/33) OF DENY2TRACE4XI - MARKED TESTED AND NOT to be traced: ", object2pickle)
            
            dictionary2pickle[key2dictionary] = 'ACK4XI' 
                    
        
            # ---------------------------------------------------------------------------------    
            # END OF DICTIONARY
            # ---------------------------------------------------------------------------------     
            # print('~' *33)              
            # print("(Step 02Z/33) OF DENY2TRACE4XI *** FAILED - ERROR IN PICKLING OBJECT - NOT TO BE TRACED: ", object2pickle)
            # print('~' *33) 
        # -----------------------------------------------------------------------------------------    
        # END OF LETTERS
        # -----------------------------------------------------------------------------------------     
        # print("(Step 02E/33) OF DENY2TRACE4XI - COMPLETED  DICTIONARY: ", dictionary2pickle)
        # 
        
    # -----------------------------------------------------------------------------------------    
    #
    # -----------------------------------------------------------------------------------------     
    # print("(Step 02F/33) OF DENY2TRACE4XI - COMPLETED LETTER : ", key2pickledb)
    # _, a ... z            
    print("(Step 033/33) OF SET2TRACE4XI - COMPLETED DENYING TRACE IN MODULES PICKLE2x4XI.PY (x=a,b...) ", time4xi()) 
#</function4xi> 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "tailor2trace4xi" usage = "
#   tailors trace 
#">                      
# -------------------------------------------------------------------------------------------------    
def tailor2trace4xi():
    global trace_object_count
    global PickleKB4Xi 
    global t2xi
 
    print("(Step 001A/33) OF TAILOR2TRACE4XI - USING T2XI: ", t2xi)
    # <print4xi.Print4Xi object at 0x0000000003715080> 
                         
    # ---------------------------------------------------------------------------------------------
    # Settings to tailor trace
    # ---------------------------------------------------------------------------------------------
    #<set4xi setting = "
    KB4Tailoring = {
        'arbitrary_address4xi': 'NACK4TRACE',
        'Connection4Xi': 'NACK4TRACE',
        'ConstantConnection4Xi': 'NACK4TRACE',
        'get_windows_system4xi': 'NACK4TRACE',
        'get_af_inet4xi': 'NACK4TRACE',
        'get_af_unix4xi': 'NACK4TRACE',
        'get_af_pipe4xi': 'NACK4TRACE',
        'ForkingPickler4Xi': 'NACK4TRACE',
        'Pipe4Xi': 'NACK4TRACE', 
        'PipeConnection4Xi': 'NACK4TRACE',
        'Popen4Xi': 'NACK4TRACE',
        'Process4Xi': 'NACK4TRACE',
        'Queue4Xi': 'NACK4TRACE',
        '_ConnectionBase4Xi': 'NACK4TRACE'
        }                             
                
    default3trace = 'NACK4TRACE' # we do NOT want trace if object is not found! 
    #"/>
    
    # ---------------------------------------------------------------------------------------------
    # PROCESS KB4Tailoring
    # ---------------------------------------------------------------------------------------------
    keys2tailor = sorted(KB4Tailoring.keys())
    for key2tailor in keys2tailor:
        # ---------------------------------------------------------------------------------    
        # NACK4XI = NOT TESTED .I.E. TO BE TRACED! 
        # ---------------------------------------------------------------------------------     
        set_param2xi = 'NACK4XI'     
        key_param = key2tailor    
        t2xi.set_print_permission(key_param, set_param2xi)
        print("(Step 002A/33) OF TAILOR_TRACE4XI - MARKED TO BE TESTED: ", key2tailor)
        # Connection4Xi
        # ConstantConnection4Xi
        # ForkingPickler4Xi
        # Pipe4Xi
        # PipeConnection4Xi
        # Popen4Xi
        # Process4Xi
        # Queue4Xi
        # _ConnectionBase4Xi
        # arbitrary_address4xi
        # get_af_inet4xi
        # get_af_pipe4xi
        # get_af_unix4xi
        # get_windows_system4xi
        
    # -----------------------------------------------------------------------------------------    
    # EOF KEYS
    # -----------------------------------------------------------------------------------------     
    print("(Step 0033/33) OF TAILOR_TRACE4XI - COMPLETED  TAILORING: ", time4xi())
    # 05:32:53 02/11/13 Pacific Standard Time

    
#</function4xi>       

 
# -------------------------------------------------------------------------------------------------
#<function4xi function = "print_trace4xi" usage = "
#   creates XML files of hello_pipe4xi
#">                       
# -------------------------------------------------------------------------------------------------    
def print_trace4xi(t2xi):
       

    # -------------------------------------------------------------------------------------------------
    # SENSE                        
    # -------------------------------------------------------------------------------------------------  
   
    context2sense = {
     'file_path4xi': '..\\..\\xml\\sense-hello-pipe4xi.xml',
     'name_space4xi': '   xmlns="http://www.dragonxi2.com/sense/sw4xi/python32/owl/multiprocessing4xi.owl#"\n',
     'xml_base4xi': '   xml:base="http://www.yourdragonxi.org/web/lib/owl/multiprocessing4xi.owl">\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Sensing of Multiprocessing4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Classes, methods and messages with context.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="Dragon4Xi#000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Sensing Hello Pipe in Multiprocessing.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="sensed#000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">Classes, Methods and Messages for Hello Pipe in Multiprocessing.</rdfs:comment>\n',
     'debug4xi': True}
      
    xml_trace_sense4xi(t2xi, context2sense)

    # -------------------------------------------------------------------------------------------------
    # REASON                         
    # -------------------------------------------------------------------------------------------------  
        
    context2reason = {
     'file_path4xi': '..\\..\\xml\\reason-hello-pipe4xi.xml',
     'name_space4xi': '   xmlns="http://www.dragonxi4.com/reason/sw4xi/python32/owl/multiprocessing4xi.owl#"\n',
     'xml_base4xi': '   xml:base="http://www.dragonxi4.com/reason/sw4xi/python32/owl/multiprocessing4xi.owl">\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Reasoning of Multiprocessing4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Operations</rdfs:comment>\n',
     'operation_comment4xi': '      <rdfs:comment xml:lang="en">Operations for Hello Pipe in Multiprocessing.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="reasoned#000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Operations Hello World in Multiprocessing.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="reason#000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">reason</rdfs:comment>\n',
     'debug4xi': True}
       
    xml_trace_reason4xi(t2xi, context2reason)

    # -------------------------------------------------------------------------------------------------
    # ACE                         
    # -------------------------------------------------------------------------------------------------  
       
    context2ace = {
     'file_path4xi': '..\\..\\xml\\ace-hello-pipe4xi.xml',
     'name_space4xi': '   xmlns="http://www.dragonxi8.com/ace/sw4xi/python32/owl/multiprocessing4xi.owl#"\n',
     'xml_base4xi': '   xml:base="http://www.dragonxi8.com/ace/sw4xi/python32/owl/multiprocessing4xi.owl">\n',
     'ontology_about4xi': '   <owl:Ontology rdf:about="Acing of Multiprocessing4Xi">\n',
     'ontology_comment4xi': '      <rdfs:comment xml:lang="en">Objects and values for Hello Pipe in Multiprocessing.</rdfs:comment>\n',
     'class0_id4xi': '   <owl:Class rdf:ID="ACE4Xi#0000000">\n',
     'class0_comment4xi': '      <rdfs:comment xml:lang="en">Objects and values for Hello Pipe in Multiprocessing.</rdfs:comment>\n',
     'object_property_rdf4xi': '   <owl:ObjectProperty rdf:ID="ace#0000000">\n',
     'object_property_comment4xi': '       <rdfs:comment xml:lang="en">000000</rdfs:comment>\n',
     'debug4xi': True}   
    
    xml_trace_ace4xi(t2xi, context2ace)


    # -------------------------------------------------------------------------------------------------
    # end of print_trace4xi                        
    # -------------------------------------------------------------------------------------------------  
#</function4xi>
  
# -------------------------------------------------------------------------------------------------
#<function4xi function = "hello_duplex_pipe" usage = "
#   testing multiprocessing duplex pipes with hello message
#">                         
# -------------------------------------------------------------------------------------------------          
def hello_duplex_pipe():   

    # -----------------------------------------------------------------------------------------    
    # 
    # -----------------------------------------------------------------------------------------    
    print("(STEP 1/33) OF HELLO_DUPLEX_PIPE - STARTING DUPLEX PIPE TESTING WITH STANDARD MULTIPROCESSING ", time4xi())
    # 05:32:53 02/11/13 Pacific Standard Time
    
    # -----------------------------------------------------------------------------------------    
    # 
    # -----------------------------------------------------------------------------------------       
    ack2wave = False
    try:
        wave2a, wave2b = Pipe(duplex=True)  # pipe becomes duplex if no parameter is given
        print("(STEP 2A/33) OF HELLO_DUPLEX_PIPE - WAVE2A ", wave2a)
        # <pipeconnection4xi.PipeConnection4Xi object at 0x00000000036DCF60>
        print("(STEP 2B/33) OF HELLO_DUPLEX_PIPE - WAVE2B ", wave2b)
        # <pipeconnection4xi.PipeConnection4Xi object at 0x00000000034E00F0>
        ack2wave = True
    except:
        print("(STEP 2Z/33) OF HELLO_DUPLEX_PIPE *** FAILED *** ACK2WAVE ", ack2wave)   
    
    
    # -----------------------------------------------------------------------------------------    
    # A SENDS GREETING TO B
    # -----------------------------------------------------------------------------------------            
    if ack2wave is True:
        try:   
            wave2a.send_bytes(b'(STEP 3A/33) OF HELLO DUPLEX PIPE: COPY B, A HERE !')
            # 
        except:
            print("(STEP 3Z/33) OF HELLO_DUPLEX_PIPE *** FAILED TO SEND *** ")
    
    # -----------------------------------------------------------------------------------------    
    # B RECEIVES GREETING FROM A
    # ----------------------------------------------------------------------------------------- 
    if ack2wave is True:
        try:            
            print("(STEP 4A/33) OF HELLO_DUPLEX_PIPE - RECEIVED: ", wave2b.recv_bytes())
            # b'(STEP 3A/33) OF HELLO DUPLEX PIPE: COPY B, A HERE !' 
        except:
            print("(STEP 4Z/33) OF HELLO_DUPLEX_PIPE *** FAILED TO RECEIVE *** ")
                
    # -----------------------------------------------------------------------------------------    
    # B ROGERS A'S GREETING
    # ----------------------------------------------------------------------------------------- 
    if ack2wave is True:
        try:             
            wave2b.send_bytes(b'(STEP 5A/33) OF HELLO DUPLEX PIPE: ROGER A, B HERE !')
        except:
            print("(STEP 5Z/33) OF HELLO_DUPLEX_PIPE *** FAILED TO SEND BYTES *** ")    
    
    # -----------------------------------------------------------------------------------------    
    # A RECEIVES B'S ROGER
    # ----------------------------------------------------------------------------------------- 
    if ack2wave is True:
        try:            
            print("(STEP 6A/33) OF HELLO_DUPLEX_PIPE - RECEIVED: ", wave2a.recv_bytes())
            # b'(STEP 5A/33) OF HELLO DUPLEX PIPE: ROGER A, B HERE !'
        except:
            print("(STEP 6Z/33) OF HELLO_DUPLEX_PIPE *** FAILED TO RECEIVE BYTES *** ")       

    # -----------------------------------------------------------------------------------------    
    # A SENDS ARRAY TO B
    # -----------------------------------------------------------------------------------------            
    if ack2wave is True:
        try:             
            arr1 = array.array('i', range(5))
            arr2 = array.array('i', [0] * 10)
            
            wave2a.send_bytes(arr1)
            print("(STEP 7A/33) OF HELLO_DUPLEX_PIPE - ARRAY SENT ARR1: ", arr1)
            # array('i', [0, 1, 2, 3, 4])
        except:
            print("(STEP 7Z/33) OF HELLO_DUPLEX_PIPE *** FAILED TO SEND ARRAY OF BYTES *** ")       
    
    # -----------------------------------------------------------------------------------------    
    # B RECEIVES ARRAY FROM A, CHECKS IT AND PRINTS IT   
    # ----------------------------------------------------------------------------------------- 
    if ack2wave is True:
        try:              
            count = wave2b.recv_bytes_into(arr2)
            print("(STEP 8A/33) OF HELLO DUPLEX PIPE: ARRAY RECEIVED BY B, ARR2: ", arr2)
            # array('i', [0, 1, 2, 3, 4, 0, 0, 0, 0, 0])
            print("(STEP 8B/33) OF HELLO DUPLEX PIPE: COUNT RECEIVED: ", count)  
            # 20
            if count == len(arr1) * arr1.itemsize:
                print("(STEP 8C/33) OF HELLO DUPLEX PIPE: COUNT RECEIVED OK : ", count) 
                # 20   
            else:
                print("(STEP 8Z1/33) OF HELLO DUPLEX PIPE ***  COUNT RECEIVED ERROR: ", count)
                print("(STEP 8Z2/33) OF HELLO DUPLEX PIPE ***  LEGTH FOR RECEIVED EXPECTED: ", len(arr1) * arr1.itemsize)
                    
        except:
            print("(STEP 8Z3/33) OF HELLO_DUPLEX_PIPE *** FAILED TO RECEIVE ARRAY OF BYTES *** ")      
      
    
        
    
    # -----------------------------------------------------------------------------------------    
    # B SENDS ACK ABOUT ARRAY
    # ----------------------------------------------------------------------------------------- 
    if ack2wave is True:
        try:     
            wave2b.send_bytes(b'(STEP 9A/33) OF HELLO DUPLEX PIPE: ARRAY RECEIVED OK, ROGER FROM B TO A!') 
                
        except:
            print("(STEP 9Z/33) OF HELLO_DUPLEX_PIPE *** FAILED TO SEND BYTES *** ")    
    
    # -----------------------------------------------------------------------------------------    
    # A RECEIVES B'S ROGER FOR ARRAY
    # ----------------------------------------------------------------------------------------- 
    if ack2wave is True:
        try:         
            print("(STEP 10A/33) OF HELLO_DUPLEX_PIPE - RECEIVED: ", wave2a.recv_bytes())
            # b'(STEP 9A/33) OF HELLO DUPLEX PIPE: ARRAY RECEIVED OK, ROGER FROM B TO A!'
        except:
            print("(STEP 9Z/33) OF HELLO_DUPLEX_PIPE *** FAILED TO RECEIVE BYTES *** ")   
                       
    
    print("(STEP 33/33): COMPLETED DUPLEX PIPE TESTING WITH STANDARD MULTIPROCESSING - ACK2WAVE: ", ack2wave)
    # True 
  
           
#</function4xi>

# -------------------------------------------------------------------------------------------------
#<function4xi function = "hello_non_duplex_pipe" usage = "
#   testing standard multiprocessing non duplex pipes with hello message
#">                         
# -------------------------------------------------------------------------------------------------          
def hello_non_duplex_pipe():   

    # -----------------------------------------------------------------------------------------    
    # NON DUPLEX
    # -----------------------------------------------------------------------------------------    
    print('=' *33)
    print("(STEP 1/33) OF HELLO NON DUPLEX PIPEXI: STARTING NON DUPLEX PIPE TESTING WITH STANDARD MULTIPROCESSING ", time4xi())  
    print('=' *33)
    
    ack2wave = False
    try:
    
        wave2read, wave2write = Pipe(duplex=False)                               # non duplex
        ack2wave = True
        
        print('=' *33)
        print("(STEP 2A/33) OF HELLO NON DUPLEX PIPEXI: WAVE2READ:")
        print(wave2read)    
        # <multiprocessing.connection.PipeConnection object at 0x0000000002C6E400>
        print('=' *33)
            
     
        print('=' *33)
        print("(STEP 2B/33) OF HELLO NON DUPLEX PIPEXI: WAVE2WRITE:")
        print(wave2write)    
        # <multiprocessing.connection.PipeConnection object at 0x00000000037ABDA0>
        print('=' *33)
    except:
 
        print('=' *33)
        print("(STEP 2Z/33) *** FAILED TO CREATE NON-DUPLEX PIPEXI *** ACK2WAVE: ", ack2wave)
        print('=' *33)
                
                  
    # -----------------------------------------------------------------------------------------    
    # CLIENTXI SENDS GREETING TO SERVERXI AS BYTES
    # -----------------------------------------------------------------------------------------            
    if ack2wave is True:
        try:   
            wave2write.send_bytes(b'(STEP 3A/33) OF NON DUPLEX HELLO PIPEXI: HELLO BXI, AXI HERE !')
        except:
            print("(STEP 3Z/33) OF NON DUPLEX HELLO PIPEXI *** FAILED TO SEND TO NON-DUPLEX PIPEXI *** ")

            
    
    
    # -----------------------------------------------------------------------------------------    
    # SERVERXI RECEIVES GREETING FROM CLIENTXI AS BYTES
    # ----------------------------------------------------------------------------------------- 
    if ack2wave is True:
        try:       
            print('(STEP 4A/33) OF NON DUPLEX HELLO PIPEXI - RECEIVED: ', wave2read.recv_bytes())
            # b'(STEP 3A/33) OF NON DUPLEX HELLO PIPEXI: HELLO BXI, AXI HERE !'
        except:
            print("(STEP 4Z1/33) OF NON DUPLEX HELLO PIPEXI *** FAILED TO RECEIVE FROM NON-DUPLEX PIPEXI *** ")
   
                  
    # -----------------------------------------------------------------------------------------    
    # CLIENTXI SENDS GREETING TO SERVERXI AS ASCII
    # -----------------------------------------------------------------------------------------            
    if ack2wave is True:
        try:   
            wave2write.send('(STEP 5A/33) OF NON DUPLEX HELLO PIPEXI: HELLO BXI, AXI HERE !')
        except:
            print("(STEP 5Z/33) OF NON DUPLEX HELLO PIPEXI *** FAILED TO SEND TO NON-DUPLEX PIPEXI *** ")

            
    
    
    # -----------------------------------------------------------------------------------------    
    # SERVERXI RECEIVES GREETING FROM CLIENTXI AS ASCII
    # ----------------------------------------------------------------------------------------- 
    if ack2wave is True:
        try:       
            print('(STEP 6A/33) OF NON DUPLEX HELLO PIPEXI - RECEIVED: ', wave2read.recv())
            # (STEP 5A/33) OF NON DUPLEX HELLO PIPEXI: HELLO BXI, AXI HERE !
        except:
            print("(STEP 6Z/33) OF NON DUPLEX HELLO PIPEXI *** FAILED TO RECEIVE FROM NON-DUPLEX PIPEXI *** ")
               
            
            
            
            
    # -----------------------------------------------------------------------------------------    
    # CLIENTXI SENDS ARRAY TO SERVERXI
    # -----------------------------------------------------------------------------------------            
    if ack2wave is True:
        try:     
            arr1 = array.array('i', range(5))
            arr2 = array.array('i', [0] * 10)
            wave2write.send_bytes(arr1)
            print("(STEP 7A/33) OF NON DUPLEX HELLO PIPEXI - ARRAY SENT ARR1: ", arr1)
            # array('i', [0, 1, 2, 3, 4])
        except:
            print("(STEP 7Z/33) OF NON DUPLEX HELLO PIPEXI  *** FAILED TO SEND TO NON-DUPLEX PIPEXI *** ")

    # -----------------------------------------------------------------------------------------    
    # SERVERXI RECEIVES ARRAY FROM CLIENTXI, CHECKS IT AND PRINTS IT   
    # ----------------------------------------------------------------------------------------- 
    if ack2wave is True:    
        try:     
            count = wave2read.recv_bytes_into(arr2)
            print("(STEP 8A/33) OF HELLO NON DUPLEX PIPEXI: ARRAY RECEIVED ARR2: ", arr2)
            # array('i', [0, 1, 2, 3, 4, 0, 0, 0, 0, 0])
            print("(STEP 8B/33) OF HELLO NON DUPLEX PIPEXI: COUNT RECEIVED COUNT: ", count) 
            # 20
            if count == len(arr1) * arr1.itemsize:
                print("(STEP 8/C) OF HELLO NON DUPLEX PIPEXI - OK RECEIVED COUNT : ", count)
                # 20
            else:
                print("(STEP 8Z1/C) OF HELLO NON DUPLEX PIPEXI *** ERROR RECEIVED COUNT *** ", count)
                print("(STEP 8Z2/C) OF HELLO NON DUPLEX PIPEXI *** EXPECTED *** ", len(arr1) * arr1.itemsize)    
        except:
            print("(STEP 8Z3/33) *** FAILED TO SEND TO NON-DUPLEX PIPEXI *** ")
    # -----------------------------------------------------------------------------------------    
    # 
    # -----------------------------------------------------------------------------------------                
    print("(STEP 33/3): COMPLETED NON DUPLEX PIPE TESTING WITH STANDARD MULTIPROCESSING - ACK2WAVE ", ack2wave)
    # True        

#</function4xi>
     
     
# -------------------------------------------------------------------------------------------------
#<function4xi function = "hello_duplex_pipe2xi" usage = "
#   testing Dragon2Xi multiprocessing duplex pipes with hello message
#">                         
# -------------------------------------------------------------------------------------------------          
def hello_duplex_pipe2xi():   

    # -----------------------------------------------------------------------------------------    
    # 
    # -----------------------------------------------------------------------------------------    
    print('=' *33)
    print("(STEP 1A/33) OF HELLO DUPLEX PIPE2XI: STARTING DUPLEX PIPE TESTING WITH LAYERED MULTIPROCESSING2XI ", time4xi()) 
    print('=' *33) 
    # 02:57:21 01/08/13 Pacific Standard Time
    
    ack2wave = False
    try:
        wave2a, wave2b = Pipe2Xi(duplex=True)        # pipe becomes duplex if no parameter is given
        ack2wave = True
        
        print("(STEP 1B/33) OF HELLO DUPLEX PIPE2XI - WAVE2A: ", wave2a)
        # <multiprocessing.connection.PipeConnection object at 0x0000000002BE91D0>
        print("(STEP 1C/33) OF HELLO DUPLEX PIPE2XI - WAVE2B: ", wave2b)
        # <multiprocessing.connection.PipeConnection object at 0x0000000003855DA0>
    except:
        print("(STEP 1Z/33) OF HELLO DUPLEX PIPE2XI *** FAILED TO CREATE WAVES *** ", Pipe2Xi)    
        
    # -----------------------------------------------------------------------------------------    
    # A SENDS GREETING TO B - NORMALLY
    # -----------------------------------------------------------------------------------------            
    if ack2wave is True:
        try:   
            wave2a.send([1, '(STEP 2A/33) OF HELLO DUPLEX PIPE2XI: HELLO B2XI, A2XI HERE !', None])
        except:
            print("(STEP 2Z/33) OF HELLO DUPLEX PIPE2XI *** FAILED TO SEND *** ", time4xi())
    
    # -----------------------------------------------------------------------------------------    
    # B2XI RECEIVES GREETING FROM A2XI - NORMALLY
    # ----------------------------------------------------------------------------------------- 
    if ack2wave is True:
        try:             
            print('(STEP 3A/33) OF HELLO DUPLEX PIPE2XI - RECEIVED: ', wave2b.recv())
            # [1, '(STEP 2A/33) OF HELLO DUPLEX PIPE2XI: HELLO B2XI, A2XI HERE !', None] 
        except:
            print("(STEP 3Z/33) OF HELLO DUPLEX PIPE2XI *** FAILED TO RECEIVE *** ", time4xi())
                
    # -----------------------------------------------------------------------------------------    
    # B2XI ROGERS A2XI'S GREETING - NORMALLY
    # ----------------------------------------------------------------------------------------- 
    if ack2wave is True:
        try:          
            wave2b.send('(STEP 4/33) OF HELLO DUPLEX PIPE2XI: ROGER A2XI, B2XI HERE !')
        except:
            print("(STEP 4Z/33) OF HELLO DUPLEX PIPE2XI *** FAILED TO SEND  *** ", time4xi())    
    
    # -----------------------------------------------------------------------------------------    
    # A2XI RECEIVES B2XI'S ROGER - NORMALLY
    # ----------------------------------------------------------------------------------------- 
    if ack2wave is True:
        try:         
            print('(STEP 5/33) OF HELLO DUPLEX PIPE2XI - RECEIVED: ', wave2a.recv())
            # (STEP 4/33) OF HELLO DUPLEX PIPE2XI: ROGER A2XI, B2XI HERE !
        except:
            print("(STEP 5Z/33) OF HELLO DUPLEX PIPE2XI *** FAILED TO RECEIVE  *** ", time4xi())           

    # -----------------------------------------------------------------------------------------    
    # A2XI SENDS ARRAY TO B2XI - BYTES
    # -----------------------------------------------------------------------------------------            
    if ack2wave is True:
        try:               
            arr1 = array.array('i', range(5))
            arr2 = array.array('i', [0] * 10)
            
            wave2a.send_bytes(arr1)
            print("(STEP 6A/33) OF HELLO DUPLEX PIPE2XI - SENT ARR1: ", arr1)
            # array('i', [0, 1, 2, 3, 4]) 
        except:
            print("(STEP 6Z/33) OF HELLO DUPLEX PIPE2XI *** FAILED TO SEND  *** ", time4xi())
                  
    # -----------------------------------------------------------------------------------------    
    # B2XI RECEIVES ARRAY FROM A2XI  - BYTES, CHECKS IT AND PRINTS IT   
    # ----------------------------------------------------------------------------------------- 
    if ack2wave is True:
        try:          
            count = wave2b.recv_bytes_into(arr2)
            print("(STEP 7A/33) OF HELLO DUPLEX PIPE2XI: RECEIVED ARR2: ", arr2)
            # array('i', [0, 1, 2, 3, 4, 0, 0, 0, 0, 0])
            print("(STEP 7B/33) OF HELLO DUPLEX PIPE2XI: RECEIVED COUNT: ", count) 
            # 20
            if count == len(arr1) * arr1.itemsize:
                print("(STEP 7C/33) OF HELLO DUPLEX PIPE2XI: OK RECEIVED COUNT: ", count)
                # 20
            else:
                print("(STEP 7Z1/33) OF HELLO DUPLEX PIPE2XI *** ERROR RECEIVED COUNT: ", count)
                print("(STEP 7Z2/33) OF HELLO DUPLEX PIPE2XI *** EXPECTED COUNT: ", len(arr1) * arr1.itemsize)            
        except:
            print("(STEP 7Z3/33) OF HELLO DUPLEX PIPE2XI *** FAILED TO RECEIVE  *** ", time4xi())           
        
    
    # -----------------------------------------------------------------------------------------    
    # B SENDS ACK ABOUT ARRAY - NORMALLY
    # ----------------------------------------------------------------------------------------- 
    if ack2wave is True:
        try:        
            wave2b.send('(STEP 8A/33) OF HELLO DUPLEX PIPE2XI: ARRAY RECEIVED OK, ROGER FROM B2XI TO A2XI!')     
        except:
            print("(STEP 8Z/33) OF HELLO DUPLEX PIPE2XI *** FAILED TO SEND  *** ", time4xi())
    
    # -----------------------------------------------------------------------------------------    
    # A2XI RECEIVES B2XI'S ROGER FOR ARRAY - NORMALLY
    # ----------------------------------------------------------------------------------------- 
    if ack2wave is True:
        try:              
            print('(STEP 9/33) OF HELLO DUPLEX PIPE2XI - RECEIVED: ', wave2a.recv())
            # (STEP 8A/33) OF HELLO DUPLEX PIPE2XI: ARRAY RECEIVED OK, ROGER FROM B2XI TO A2XI!
        except:
            print("(STEP 8Z/33) OF HELLO DUPLEX PIPE2XI *** FAILED TO RECEIVE  *** ", time4xi())
             
    # -----------------------------------------------------------------------------------------    
    # 
    # -----------------------------------------------------------------------------------------                                   
    print('=' *33)
    print("(STEP 33/33) OF HELLO DUPLEX - COMPLETED DUPLEX PIPE TESTING WITH LAYERED MULTIPROCESSING2XI ", time4xi())
    # 03:01:07 01/08/13 Pacific Standard Time
    print('=' *33) 

#</function4xi>

# -------------------------------------------------------------------------------------------------
#<function4xi function = "hello_non_duplex_pipe2xi" usage = "
#   testing Dragon2Xi multiprocessing non duplex pipes with hello message
#">                         
# -------------------------------------------------------------------------------------------------          
def hello_non_duplex_pipe2xi():    

    # -----------------------------------------------------------------------------------------    
    # NON DUPLEX
    # -----------------------------------------------------------------------------------------    
    print('=' *33)
    print("(STEP 1/33) OF HELLO NON DUPLEX PIPE2XI: STARTING NON DUPLEX PIPE TESTING WITH LAYERED MULTIPROCESSING2XI ", time4xi())
    # 03:07:07 01/08/13 Pacific Standard Time
    print('=' *33)
    
    try:
    
        wave2read, wave2write = Pipe2Xi(duplex=False)                               # non duplex
 
        print('=' *33)
        print("(STEP 2A/33) OF HELLO NON DUPLEX PIPE2XI: WAVE2READ:")
        print(wave2read)    
        # <multiprocessing.connection.PipeConnection object at 0x0000000002BFB1D0>
        print('=' *33)
            
     
        print('=' *33)
        print("(STEP 2B/33) OF HELLO NON DUPLEX PIPE2XI: WAVE2WRITE:")
        print(wave2write)    
        # <multiprocessing.connection.PipeConnection object at 0x000000000363ADA0>
        print('=' *33)
    except:
 
        print('=' *33)
        print("(STEP 2Z/33) *** FAILED TO CREATE NON-DUPLEX PIPE2XI *** ")
        print(wave2read)    
        print('=' *33)
                
                  
    # -----------------------------------------------------------------------------------------    
    # CLIENT2XI SENDS GREETING TO SERVER2XI - NORMALLY
    # -----------------------------------------------------------------------------------------            
    try:   
        wave2write.send([1, '(STEP 3A/33) OF NON DUPLEX HELLO PIPE2XI: HELLO B2XI, A2XI HERE !', None])
    except:
 
        print('=' *33)
        print("(STEP 3Z/33) *** FAILED TO SEND TO NON-DUPLEX PIPE2XI *** ")
        print(wave2read)    
        print('=' *33)
            
    
    
    # -----------------------------------------------------------------------------------------    
    # SERVER2XI RECEIVES GREETING FROM CLIENT2XI - NORMALLY
    # ----------------------------------------------------------------------------------------- 
    try:       
        print('(STEP 4A/33) OF NON DUPLEX HELLO PIPE2XI - RECEIVED: ', wave2read.recv())
    except:
 
        print('=' *33)
        print("(STEP 4Z/33) *** FAILED TO RECEIVE FROM NON-DUPLEX PIPE2XI *** ")
        print(wave2read)    
        # [1, '(STEP 3A/33) OF NON DUPLEX HELLO PIPE2XI: HELLO B2XI, A2XI HERE !', None]
        print('=' *33)
             
        
        
    # -----------------------------------------------------------------------------------------    
    # CLIENT2XI SENDS ARRAY TO SERVER2XI - BYTES
    # -----------------------------------------------------------------------------------------            
   
    arr1 = array.array('i', range(5))
    arr2 = array.array('i', [0] * 10)

    try:          
        wave2write.send_bytes(arr1)
    except:
 
        print('=' *33)
        print("(STEP 5Z/33) *** FAILED TO SEND TO NON-DUPLEX PIPE2XI *** ")
        print(wave2read)
        print('=' *33)    

    
    # -----------------------------------------------------------------------------------------    
    # SERVER2XI RECEIVES ARRAY FROM CLIENT2XI, CHECKS IT AND PRINTS IT  - BYTES INTO ARRAY  
    # ----------------------------------------------------------------------------------------- 
    try:     
        count = wave2read.recv_bytes_into(arr2)
        print("(STEP 6A/33) OF HELLO NON DUPLEX PIPE2XI: ARRAY RECEIVED BY B2XI: ")
        print(arr2) 
        # array('i', [0, 1, 2, 3, 4, 0, 0, 0, 0, 0])
          
        assert count == len(arr1) * arr1.itemsize
            
        print("(STEP 6B/33) OF HELLO NON DUPLEX PIPE2XI: ASSERTED ARRAY BY B2XI ", time4xi())
    except:
 
        print('=' *33)
        print("(STEP 6Z/33) *** FAILED TO SEND TO NON-DUPLEX PIPE2XI *** ")
        print(wave2read)    
        print('=' *33)    
               
    print('=' *33)
    print("(STEP 3/33): COMPLETED NON DUPLEX PIPE TESTING WITH LAYERED MULTIPROCESSING2XI ", time4xi())
    # 03:07:07 01/08/13 Pacific Standard Time
    print('=' *33)        
    
#</function4xi>
     
     
# -------------------------------------------------------------------------------------------------
#<function4xi function = "hello_duplex_pipe4xi" usage = "
#   testing Dragon2Xi multiprocessing duplex pipes with hello message
#">                         
# -------------------------------------------------------------------------------------------------          
def hello_duplex_pipe4xi():   

    # -----------------------------------------------------------------------------------------    
    # 
    # -----------------------------------------------------------------------------------------    
    print('=' *33)
    print("(STEP 1A/33) OF HELLO DUPLEX PIPE4XI: STARTING DUPLEX PIPE TESTING WITH DRAGONIZED MULTIPROCESSING4XI ", time4xi())    
    print('=' *33)
    # 05:29:58 02/18/13 Pacific Standard Time
    
    ack2wave = False
    try:
        wave4a, wave4b = Pipe4Xi(duplex=True)        # pipe becomes duplex if no parameter is given
        ack2wave = True
        
        print("(STEP 1B/33) OF HELLO DUPLEX PIPE4XI - WAVE2A: ", wave4a)
        # <pipeconnection4xi.PipeConnection4Xi object at 0x00000000034C20F0>
        print("(STEP 1C/33) OF HELLO DUPLEX PIPE4XI - WAVE2B: ", wave4b)
        # <pipeconnection4xi.PipeConnection4Xi object at 0x00000000037BDBE0>
    except:
        print("(STEP 1Z/33) OF HELLO DUPLEX PIPE4XI *** FAILED TO CREATE WAVES *** ", Pipe4Xi)    
        # 
        
    # -----------------------------------------------------------------------------------------    
    # A SENDS GREETING TO B - NORMALLY
    # -----------------------------------------------------------------------------------------
    print('=' *33)
    print("(STEP 2/33) OF HELLO DUPLEX PIPE4XI: A SENDS GREETING TO B ", time4xi())  
    # 
    print('=' *33)                
    if ack2wave is True:
        try:   
            wave4a.send([1, '(STEP 2A/33) OF HELLO DUPLEX PIPE4XI: HELLO B4XI, A4XI HERE !', None])
            # { _ConnectionBase4Xi : send ; (Step 1/7b) passed; obj-passed-to-send-ConnectionBase4Xi: [1, '(STEP 2A/33) OF HELLO DUPLEX PIPE4XI: HELLO B4XI, A4XI HERE !', None]
            # { ForkingPickler4Xi : dump ; passed; object-passed-to-dump-of-ForkingPickler4Xi: [1, '(STEP 2A/33) OF HELLO DUPLEX PIPE4XI: HELLO B4XI, A4XI HERE !', None]
            # { ForkingPickler4Xi : save ; (Step 1/9b) passed; object-passed-to-save-of-ForkingPickler4Xi: [1, '(STEP 2A/33) OF HELLO DUPLEX PIPE4XI: HELLO B4XI, A4XI HERE !', None]
            # { ForkingPickler4Xi : persistent-id ; passed; object-passed-to-persistent-id-of-ForkingPickler4Xi: [1, '(STEP 2A/33) OF HELLO DUPLEX PIPE4XI: HELLO B4XI, A4XI HERE !', None]
            # { ForkingPickler4Xi : save ; (Step 3/9a2) passing; object-passing-to-type-by-save-of-ForkingPickler4Xi: [1, '(STEP 2A/33) OF HELLO DUPLEX PIPE4XI: HELLO B4XI, A4XI HERE !', None]
            # { ForkingPickler4Xi : save-list ; passed; object-passed-to-save-list-of-ForkingPickler4Xi: [1, '(STEP 2A/33) OF HELLO DUPLEX PIPE4XI: HELLO B4XI, A4XI HERE !', None]
            # { ForkingPickler4Xi : save-list ; passing; object-passing-to-memoize-by-save-list-of-ForkingPickler4Xi: [1, '(STEP 2A/33) OF HELLO DUPLEX PIPE4XI: HELLO B4XI, A4XI HERE !', None]
            # { ForkingPickler4Xi : memoize ; added; memo-of-forkingpickler2xi-added-by-memoize-of-ForkingPickler4Xi: (0, [1, '(STEP 2A/33) OF HELLO DUPLEX PIPE4XI: HELLO B4XI, A4XI HERE !', None])
            # { ForkingPickler4Xi : save-list ; passing; object-passing-to-batch-appends-by-save-list-of-ForkingPickler4Xi: [1, '(STEP 2A/33) OF HELLO DUPLEX PIPE4XI: HELLO B4XI, A4XI HERE !', None]
            # { ForkingPickler4Xi : batch-appends ; passed; items-passed-to-batch-appends-of-ForkingPickler4Xi: [1, '(STEP 2A/33) OF HELLO DUPLEX PIPE4XI: HELLO B4XI, A4XI HERE !', None]
            # 
        except:
            print("(STEP 2Z/33) OF HELLO DUPLEX PIPE4XI *** FAILED TO SEND *** ", time4xi())
    
    # -----------------------------------------------------------------------------------------    
    # B4XI RECEIVES GREETING FROM A4XI - NORMALLY
    # ----------------------------------------------------------------------------------------- 
    print('=' *33)
    print("(STEP 3A/33) OF HELLO DUPLEX PIPE4XI: B4XI RECEIVES GREETING FROM A4XI ", time4xi()) 
    # 05:29:58 02/18/13 Pacific Standard Time
    print('=' *33)       
    if ack2wave is True:
        try:             
            print("(STEP 3B/33) OF HELLO DUPLEX PIPE4XI - RECEIVED MESSAGE: ", wave4b.recv())  
            # [1, '(STEP 2A/33) OF HELLO DUPLEX PIPE4XI: HELLO B4XI, A4XI HERE !', None]
        except:
            print("(STEP 3Z/33) OF HELLO DUPLEX PIPE4XI *** FAILED TO RECEIVE *** ", time4xi())
                
    # -----------------------------------------------------------------------------------------    
    # B4XI ROGERS A4XI'S GREETING - NORMALLY
    # ----------------------------------------------------------------------------------------- 
    print('=' *33)
    print("(STEP 4/33) OF HELLO DUPLEX PIPE4XI: B4XI ROGERS A4XI'S GREETING ", time4xi())  
    # 
    print('=' *33)       
    if ack2wave is True:
        try:          
            wave4b.send('(STEP 4/33) OF HELLO DUPLEX PIPE4XI: ROGER A4XI, B4XI HERE !')
        except:
            print("(STEP 4Z/33) OF HELLO DUPLEX PIPE4XI *** FAILED TO SEND  *** ", time4xi())    
    
    # -----------------------------------------------------------------------------------------    
    # A4XI RECEIVES B4XI'S ROGER - NORMALLY
    # ----------------------------------------------------------------------------------------- 
    print('=' *33)
    print("(STEP 5A/33) OF HELLO DUPLEX PIPE4XI: A4XI RECEIVES B4XI'S ROGER ", time4xi()) 
    # 
    print('=' *33)     
    if ack2wave is True:
        try: 

            print("(STEP 5B2/33) OF HELLO DUPLEX PIPE4XI - RECEIVED MESSAGE: ", wave4a.recv())
            # (STEP 4/33) OF HELLO DUPLEX PIPE4XI: ROGER A4XI, B4XI HERE !
        except:
            print("(STEP 5Z/33) OF HELLO DUPLEX PIPE4XI *** FAILED TO RECEIVE  *** ", time4xi())           

                
    # -----------------------------------------------------------------------------------------    
    # B4XI ROGERS A4XI'S GREETING - BYTES 
    # ----------------------------------------------------------------------------------------- 
    print('=' *33)
    print("(STEP 6/33) OF HELLO DUPLEX PIPE4XI: B4XI ROGERS A4XI'S GREETING ", time4xi()) 
    # 
    print('=' *33)       
    if ack2wave is True:
        try:          
            wave4b.send_bytes(b'(STEP 4/33) OF HELLO DUPLEX PIPE4XI: ROGER A4XI, B4XI HERE !')
        except:
            print("(STEP 6Z/33) OF HELLO DUPLEX PIPE4XI *** FAILED TO SEND  *** ", time4xi())    
    
    # -----------------------------------------------------------------------------------------    
    # A4XI RECEIVES B4XI'S ROGER - BYTES 
    # ----------------------------------------------------------------------------------------- 
    print('=' *33)
    print("(STEP 7A/33) OF HELLO DUPLEX PIPE4XI: A4XI RECEIVES B4XI'S ROGER ", time4xi()) 
    # 
    print('=' *33)     
    if ack2wave is True:
        try:
            print("(STEP 7B/33) OF HELLO DUPLEX PIPE4XI - RECEIVED MESSAGE: ", wave4a.recv_bytes())
            # b'(STEP 4/33) OF HELLO DUPLEX PIPE4XI: ROGER A4XI, B4XI HERE !'
        except:
            print("(STEP 7Z/33) OF HELLO DUPLEX PIPE4XI *** FAILED TO RECEIVE  *** ", time4xi())                 
            
            
            
    # -----------------------------------------------------------------------------------------    
    # A4XI SENDS ARRAY TO B4XI - BYTES 
    # -----------------------------------------------------------------------------------------            
    print('=' *33)
    print("(STEP 8/33) OF HELLO DUPLEX PIPE4XI: A4XI SENDS ARRAY TO B4XI ", time4xi()) 
    # 
    print('=' *33)       
    if ack2wave is True:
        try:               
            arr1 = array.array('i', range(5))
            arr2 = array.array('i', [0] * 10)
            
            wave4a.send_bytes(arr1)
            print("(STEP 8A/33) OF HELLO DUPLEX PIPE4XI - SENT ARR1: ", arr1)
            # array('i', [0, 1, 2, 3, 4]) 
        except:
            print("(STEP 8Z/33) OF HELLO DUPLEX PIPE4XI *** FAILED TO SEND  *** ", time4xi())
                  
    # -----------------------------------------------------------------------------------------    
    # B4XI RECEIVES ARRAY FROM A4XI, CHECKS IT AND PRINTS IT  - BYTES   
    # ----------------------------------------------------------------------------------------- 
    print('=' *33)
    print("(STEP 9A/33) OF HELLO DUPLEX PIPE4XI: B4XI RECEIVES ARRAY FROM A4XI, CHECKS IT AND PRINTS IT ", time4xi()) 
    # 
    print('=' *33)        
    if ack2wave is True:
        try:          
            count = wave4b.recv_bytes_into(arr2)
            print("(STEP 9B/33) OF HELLO DUPLEX PIPE4XI: RECEIVED ARR2: ", arr2)
            # array('i', [0, 1, 2, 3, 4, 0, 0, 0, 0, 0])
            print("(STEP 9C/33) OF HELLO DUPLEX PIPE4XI: RECEIVED COUNT: ", count) 
            # 20
            if count == len(arr1) * arr1.itemsize:
                print("(STEP 9D/33) OF HELLO DUPLEX PIPE4XI: OK RECEIVED COUNT: ", count)
                # 20
            else:
                print("(STEP 9Z1/33) OF HELLO DUPLEX PIPE4XI *** ERROR RECEIVED COUNT: ", count)
                print("(STEP 9Z2/33) OF HELLO DUPLEX PIPE4XI *** EXPECTED COUNT: ", len(arr1) * arr1.itemsize)            
        except:
            print("(STEP 9Z3/33) OF HELLO DUPLEX PIPE4XI *** FAILED TO RECEIVE  *** ", time4xi())           
        
    
    # -----------------------------------------------------------------------------------------    
    # B SENDS ACK ABOUT ARRAY - NORMALLY
    # ----------------------------------------------------------------------------------------- 
    print('=' *33)
    print("(STEP 10/33) OF HELLO DUPLEX PIPE4XI: B SENDS ACK ABOUT ARRAY ", time4xi()) 
    # 
    print('=' *33)       
    if ack2wave is True:
        try:        
            wave4b.send('(STEP 10A/33) OF HELLO DUPLEX PIPE4XI: ARRAY RECEIVED OK, ROGER FROM B4XI TO A4XI!')     
        except:
            print("(STEP 10Z/33) OF HELLO DUPLEX PIPE4XI *** FAILED TO SEND  *** ", time4xi())
    
    # -----------------------------------------------------------------------------------------    
    # A4XI RECEIVES B4XI'S ROGER FOR ARRAY - NORMALLY
    # ----------------------------------------------------------------------------------------- 
    print('=' *33)
    print("(STEP 11A/33) OF HELLO DUPLEX PIPE4XI: A4XI RECEIVES B4XI'S ROGER FOR ARRAY ", time4xi()) 
    # 
    print('=' *33)     
    if ack2wave is True:
        try:              
            print("(STEP 11B/33) OF HELLO DUPLEX PIPE4XI - RECEIVED: ", wave4a.recv())
            # (STEP 10A/33) OF HELLO DUPLEX PIPE4XI: ARRAY RECEIVED OK, ROGER FROM B4XI TO A4XI!
        except:
            print("(STEP 11Z/33) OF HELLO DUPLEX PIPE4XI *** FAILED TO RECEIVE  *** ", time4xi())
             
    # -----------------------------------------------------------------------------------------    
    # 
    # -----------------------------------------------------------------------------------------                                   
    print('=' *33)
    print("(STEP 33A/33) OF HELLO DUPLEX PIPE4XI: FINAL ", time4xi()) 
    # 
    print('=' *33)      
    if ack2wave is True:
        print('=' *33)
        print("(STEP 33B/33) OF HELLO DUPLEX PIPE4XI - COMPLETED DUPLEX PIPE TESTING WITH DRAGONIZED MULTIPROCESSING4XI ", time4xi())
        # 
        print('=' *33) 
    else:
        print("(STEP 33Z/33) OF HELLO DUPLEX PIPE4XI *** FAILED IN DUPLEX PIPE TESTING WITH WITH DRAGONIZED MULTIPROCESSING4XI, ACK2WAVE: ", ack2wave)
        # 
#</function4xi>

     
# -------------------------------------------------------------------------------------------------
#<function4xi function = "hello_non_duplex_pipe4xi" usage = "
#   testing Dragon4Xi multiprocessing non duplex pipes with hello message
#">                         
# -------------------------------------------------------------------------------------------------          
def hello_non_duplex_pipe4xi():   

    # -----------------------------------------------------------------------------------------    
    # NON DUPLEX
    # -----------------------------------------------------------------------------------------    
    print('=' *33)
    print("(STEP 1/33) OF HELLO NON DUPLEX PIPE4XI - STARTING NON DUPLEX PIPE TESTING WITH DRAGONIZED MULTIPROCESSING4XI ", time4xi())
    print('=' *33)
    # 05:33:48 02/18/13 Pacific Standard Time
    ack2waves = False
    try:
    
        wave2read, wave2write = Pipe4Xi(duplex=False)                               # non duplex
        ack2waves = True
        print('=' *33)
        print("(STEP 2A/33) OF HELLO NON DUPLEX PIPE4XI: WAVE2READ:")
        print(wave2read)
        # <pipeconnection4xi.PipeConnection4Xi object at 0x00000000034510F0>
        print('=' *33)
            
     
        print('=' *33)
        print("(STEP 2B/33) OF HELLO NON DUPLEX PIPE4XI: WAVE2WRITE:")
        print(wave2write)
        # <pipeconnection4xi.PipeConnection4Xi object at 0x0000000003677400>
        print('=' *33)
    except:
        print("(STEP 2Z/33) OF HELLO NON DUPLEX PIPE4XI *** FAILED TO CREATE NON-DUPLEX PIPE4XI *** ACK2WAVES: ", ack2waves)
        # 
                
                  
    # -----------------------------------------------------------------------------------------    
    # CLIENT4XI SENDS GREETING TO SERVER4XI - NORMALLY
    # -----------------------------------------------------------------------------------------            
    print("(STEP 3/33) OF HELLO NON DUPLEX PIPE4XI - CLIENT4XI SENDS GREETING TO SERVER4XI ", time4xi())    
    # 07:11:04 02/11/13 Pacific Standard Time            
    if ack2waves is True:
        try:
            
            wave2write.send([1, '(STEP 3A/33) OF NON DUPLEX HELLO PIPE4XI - HELLO B4XI, A4XI HERE !', None])
            #  _ConnectionBase4Xi : send ; (Step 1/7b) passed; obj-passed-to-send-ConnectionBase4Xi: [1, '(STEP 3A/33) OF NON DUPLEX HELLO PIPE4XI - HELLO B4XI, A4XI HERE !', None]
            
        except:
            print('=' *33)
            print("(STEP 3Z/33) OF NON DUPLEX HELLO PIPE4XI *** FAILED TO SEND TO NON-DUPLEX PIPE4XI *** ", time4xi())   
            print(wave2write)    
            print('=' *33)
            
    
    
    # -----------------------------------------------------------------------------------------    
    # SERVER4XI RECEIVES GREETING FROM CLIENT4XI - NORMALLY
    # ----------------------------------------------------------------------------------------- 
    print("(STEP 4/33) OF HELLO NON DUPLEX PIPE4XI - SERVER4XI RECEIVES GREETING FROM CLIENT4XI ", time4xi())    
    # 07:11:04 02/11/13 Pacific Standard Time
            
    if ack2waves is True:
        try:
            
            greeting2receive = wave2read.recv()
            
            print("(STEP 4B/33) OF HELLO NON DUPLEX PIPE4XI - GREETING2RECEIVE: ", greeting2receive)  
            # [1, '(STEP 3A/33) OF NON DUPLEX HELLO PIPE4XI - HELLO B4XI, A4XI HERE !', None]
        except:
            print("(STEP 4Z/33) OF NON DUPLEX HELLO PIPE4XI *** FAILED TO RECEIVE FROM NON-DUPLEX PIPE4XI *** ", time4xi())   
            
        
        
    # -----------------------------------------------------------------------------------------    
    # CLIENT4XI SENDS ARRAY TO SERVER4XI - BYTES
    # -----------------------------------------------------------------------------------------            
    print("(STEP 5/33) OF HELLO NON DUPLEX PIPE4XI - CLIENT4XI SENDS ARRAY TO SERVER4XI ", time4xi())    
    # 05:33:48 02/18/13 Pacific Standard Time
    if ack2waves is True:
        arr1 = array.array('i', range(5))
        arr2 = array.array('i', [0] * 10)
    
        try:
            print("(STEP 5A/33) OF HELLO NON DUPLEX PIPE4XI - READY TO SEND ARR1: ", arr1)            
            # array('i', [0, 1, 2, 3, 4])
            
            wave2write.send_bytes(arr1)
            
            print("(STEP 5B/33) OF HELLO NON DUPLEX PIPE4XI - SENT ARR1: ", arr1)
            # array('i', [0, 1, 2, 3, 4])
        except:
            print('=' *33)
            print("(STEP 5Z/33) OF NON DUPLEX HELLO PIPE4XI *** FAILED TO SEND TO NON-DUPLEX PIPE4XI *** ARR1:  ", arr1)
            print('=' *33)    
    
    
    # -----------------------------------------------------------------------------------------    
    # SERVER4XI RECEIVES ARRAY FROM CLIENT4XI, CHECKS IT AND PRINTS IT - BYTES INTO ARRAY
    # ----------------------------------------------------------------------------------------- 
    print("(STEP 6/33) OF HELLO NON DUPLEX PIPE4XI - SERVER4XI RECEIVES ARRAY FROM CLIENT4XI, CHECKS IT AND PRINTS IT ", time4xi())    
    # 05:33:48 02/18/13 Pacific Standard Time
    if ack2waves is True:
        try:
            print("(STEP 6A/33) OF HELLO NON DUPLEX PIPE4XI - READY TO RECEIVE ", time4xi()) 
            # 05:33:48 02/18/13 Pacific Standard Time
        except:
            print("(STEP 6Z1/33) OF HELLO NON DUPLEX PIPE4XI *** FAILED IN READY TO RECEIVE NON-DUPLEX PIPE4XI *** ")    
        try:    
            print("(STEP 6B/33) OF HELLO NON DUPLEX PIPE4XI - USING WAVE2READ.RECV_BYTES_INTO ", wave2read.recv_bytes_into)
            # <bound method PipeConnection4Xi.recv_bytes_into of <pipeconnection4xi.PipeConnection4Xi object at 0x0000000003700F98>> 
        except:
            print("(STEP 6Z2/33) OF HELLO NON DUPLEX PIPE4XI *** FAILED IN USING WAVE2READ.RECV_BYTES_INTO *** ")
            
                        
        print("(STEP 6C/33) OF HELLO NON DUPLEX PIPE4XI - CALLING WAVE2READ.RECV_BYTES_INTO ", wave2read.recv_bytes_into)         
        # <bound method PipeConnection4Xi.recv_bytes_into of <pipeconnection4xi.PipeConnection4Xi object at 0x0000000003700F98>>
        try:                   
            count = wave2read.recv_bytes_into(arr2)
            
            print("(STEP 6B/33) OF HELLO NON DUPLEX PIPE4XI - RECEIVED COUNT: ", count)
            # 20
            
            if count == len(arr1) * arr1.itemsize:
                print("(STEP 6C/33) OF HELLO NON DUPLEX PIPE4XI - ASSERTED COUNT: ", count)
                # 20
                print("(STEP 6D/33) OF HELLO NON DUPLEX PIPE4XI - RECEIVED ARR2: ", arr2)
                # array('i', [0, 1, 2, 3, 4, 0, 0, 0, 0, 0])
            else:
                print("(STEP 6Z1/33) OF HELLO NON DUPLEX PIPE4XI *** RECEIVED COUNT: ", count)
                print("(STEP 6Z2/33) OF HELLO NON DUPLEX PIPE4XI *** EXPECTED: ", len(arr1) * arr1.itemsize)
                     
        except:
            print('=' *33)
            print("(STEP 6Z3/33) OF HELLO NON DUPLEX PIPE4XI *** FAILED TO RECEIVE NON-DUPLEX PIPE4XI *** ")
            print('=' *33)    
    
    # -----------------------------------------------------------------------------------------    
    #  
    # -----------------------------------------------------------------------------------------                
    if ack2waves is True:
        print('=' *33)
        print("(STEP 33A/33) OF HELLO NON DUPLEX PIPE4XI - COMPLETED NON DUPLEX PIPE TESTING WITH DRAGONIZED MULTIPROCESSING4XI, ACK2WAVES: ", ack2waves)
        # COMPLETED NON DUPLEX PIPE TESTING WITH DRAGONIZED MULTIPROCESSING4XI, ACK2WAVES:  True
        print('=' *33)
    else:
        print("(STEP 33Z/33) OF HELLO NON DUPLEX PIPE4XI *** FAILED IN NON DUPLEX PIPE TESTING WITH DRAGONIZED MULTIPROCESSING4XI *** , ACK2WAVES: ", ack2waves)     
        # 
#</function4xi>

# -------------------------------------------------------------------------------------------------
#<function4xi function = "hello_pipe" usage = "
#   testing Pipe
#"> 
#<state4xi status = "ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------    
def hello_pipe():
    try:
        print("(Step 1A/33) OF HELLO_PIPE - HELLO_DUPLEX_PIPE: ", hello_duplex_pipe)
        # <function hello_duplex_pipe at 0x000000000365ED08>
        hello_duplex_pipe()
    except:
        print("(Step 1Z/33) OF HELLO_PIPE *** FAILED IN HELLO_DUPLEX_PIPE *** ", hello_duplex_pipe)
    
    try:    
        print("(Step 2A/33) OF HELLO_PIPE - HELLO_NON_DUPLEX_PIPE: ", hello_non_duplex_pipe) 
        # <function hello_non_duplex_pipe at 0x00000000037EED90>
        hello_non_duplex_pipe()    
    except:
        print("(Step 2Z/33) OF HELLO_PIPE *** FAILED IN HELLO_NON_DUPLEX_PIPE *** ", hello_non_duplex_pipe)              
#</function4xi>


# -------------------------------------------------------------------------------------------------
#<function4xi function = "hello_pipe2xi" usage = "
#   testing Pipe2Xi
#"> 
#<state4xi status = "ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------    
def hello_pipe2xi():
    try:
        print("(Step 1A/33) OF HELLO_PIPE2XI - HELLO_DUPLEX_PIPE2XI: ", hello_duplex_pipe2xi)
        # function hello_duplex_pipe2xi at 0x00000000037EEE18>
        hello_duplex_pipe2xi()
    except:
        print("(Step 1Z/33) OF HELLO_PIPE2XI *** FAILED IN HELLO_DUPLEX_PIPE2XI *** ", hello_duplex_pipe2xi)
    try:
        print("(Step 2A/33) OF HELLO_PIPE2XI - HELLO_NON_DUPLEX_PIPE2XI: ", hello_non_duplex_pipe2xi)        
        # <function hello_non_duplex_pipe2xi at 0x000000000365EEA0>
        hello_non_duplex_pipe2xi()        
    except:
        print("(Step 2Z/33) OF HELLO_PIPE2XI *** FAILED IN HELLO_NON_DUPLEX_PIPE2XI *** ", hello_non_duplex_pipe2xi)            
#</function4xi>

# -------------------------------------------------------------------------------------------------
#<function4xi function = "hello_pipe4xi" usage = "
#   testing Pipe4Xi
#"> 
#<state4xi status = "ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------    
def hello_pipe4xi():
    global t2xi
    global trace_object_count    
        
    # --------------------------------------------------------------------------------------------- 
    # INITIALIZE TRACE
    # ---------------------------------------------------------------------------------------------        
    t2xi = Print4Xi()
    print("(Step 1/33) OF HELLO_PIPE4XI - SET T2XI TO: ", t2xi)
    # <print4xi.Print4Xi object at 0x0000000002D16400> 
    set2trace4xi()                                                                                               # trace all classes and functions in the system
    deny2trace4xi()                                                                                              # deny trace for all classes and functions in the system
    tailor2trace4xi()                                                                                            # tailor trace for this test   
    
    try:
        print("(Step 2A/33) OF HELLO_PIPE4XI - HELLO_DUPLEX_PIPE4XI ", hello_duplex_pipe4xi)
        # <function hello_duplex_pipe4xi at 0x000000000365EF28>
        hello_duplex_pipe4xi()    
        
    except:
        print("(Step 2Z/33) OF HELLO_PIPE4XI *** FAILED IN HELLO_DUPLEX_PIPE4XI ", hello_duplex_pipe4xi)
    
    try:
        print("(Step 3A/33) OF HELLO_PIPE4XI - HELLO_DUPLEX_PIPE4XI ", hello_non_duplex_pipe4xi)
        # <function hello_non_duplex_pipe4xi at 0x000000000361B268>
        hello_non_duplex_pipe4xi()   
        
    except:
        print("(Step 3Z/33) OF HELLO_PIPE4XI *** FAILED IN HELLO_NON_DUPLEX_PIPE4XI *** ", hello_non_duplex_pipe4xi)

    finally:       
    
        # -----------------------------------------------------------------------------------------    
        # PRINT TRACE
        # -----------------------------------------------------------------------------------------     
        print("(Step 33/3) OF HELLO_PIPE4XI - PRINT_TRACE4XI WITH T2XI ", t2xi)
        # <print4xi.Print4Xi object at 0x0000000002C9E470>
        print_trace4xi(t2xi) 
                               
#</function4xi>


# -------------------------------------------------------------------------------------------------
#<function4xi function = "main" usage = "
# main function for hello_pipe4xi
#"> 
#<state4xi status = "ACK4tagging; NACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------    
def main():

    print('=' *33)
    print("(STEP 0/4) OF HELLO_PIPE4XI - SENSING IT!", time4xi())  
    # 07:59:49 01/08/13 Pacific Standard Time
    print('=' *33)   

    print('=' *33)
    print("(STEP 1A/4) OF HELLO_PIPE4XI - SENSING MULTIPROCESSING PIPES! ", time4xi())  
    # 07:59:49 01/08/13 Pacific Standard Time
    print('=' *33)

    hello_pipe()
    
    print('=' *33)
    print("(STEP 1B/4) OF HELLO_PIPE4XI - SENSED MULTIPROCESSING PIPES! ", time4xi())  
    # 07:59:49 01/08/13 Pacific Standard Time
    print('=' *33)    
        

    print('=' *33)
    print("(STEP 2A/4) OF HELLO_PIPE4XI - SENSING MULTIPROCESSING2XI PIPES! ", time4xi())  
    # 07:59:49 01/08/13 Pacific Standard Time
    print('=' *33) 
                   
    hello_pipe2xi()

    print('=' *33)
    print("(STEP 2B/4) OF HELLO_PIPE4XI - SENSED MULTIPROCESSING2XI PIPES! ", time4xi())  
    # 07:59:49 01/08/13 Pacific Standard Time
    print('=' *33)    
            
    print('=' *33)
    print("(STEP 3A/4) OF HELLO_PIPE4XI - SENSING MULTIPROCESSING4XI PIPES! ", time4xi())  
    # 07:59:49 01/08/13 Pacific Standard Time
    print('=' *33)
    
    hello_pipe4xi()
    
    print('=' *33)
    print("(STEP 3B/4) OF HELLO_PIPE4XI - SENSED MULTIPROCESSING4XI PIPES! ", time4xi())  
    # 07:59:49 01/08/13 Pacific Standard Time
    print('=' *33)
    
    print('=' *33)
    print("(STEP 4/4) OF HELLO_PIPE4XI - SENSED!", time4xi())  
    # 07:59:49 01/08/13 Pacific Standard Time
    print('=' *33)        
                              
#</function4xi>
       

# -------------------------------------------------------------------------------------------------
#                           
# -------------------------------------------------------------------------------------------------      
if __name__ == '__main__':

    main()    
     
#</program4xi>
 


# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_hello_pipe4xi.txt
#   sense-hello-pipe4xi.xml
#   reason-hello-pipe4xi.xml
#   ace-hello-pipe4xi.xml
#"
#>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 
#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of hello_pipe4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>


